"use strict";

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

require("core-js/modules/es7.object.get-own-property-descriptors.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createFilter = createFilter;

require("core-js/modules/es6.array.filter.js");

require("core-js/modules/es6.array.map.js");

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.string.includes.js");

require("core-js/modules/es7.array.includes.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

require("core-js/modules/es6.object.get-own-property-names.js");

var _utils = require("./utils");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function createFilter(map, valueMap) {
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var filter = options.filter || function (value) {
    var defaultLabel = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
    var label = map[value];
    if (!label) return defaultLabel;
    return _typeof(label) === 'object' ? label.label || defaultLabel : label;
  };

  filter.map = map;
  var list = Object.keys(map).map(function (value, index) {
    var label = filter.map[value];
    var rest = {};

    if (label && (0, _utils.isPlainObject)(label)) {
      var labelObj = label;
      Object.keys(labelObj).forEach(function (key) {
        if (key === 'label') label = labelObj[key];else rest[key] = labelObj[key];
      });
    }

    var item = _objectSpread({
      value: value,
      label: label
    }, rest);

    var isContinue = options.onWalkListItem && options.onWalkListItem(item, index);
    if (isContinue === false) return;
    return (0, _utils.isPlainObject)(isContinue) ? isContinue : item;
  }).filter(Boolean);
  filter.list = list;

  var createList = function createList(values) {
    return filter.list.filter(function (v) {
      return !values || values.includes(v.value);
    });
  };

  filter.createList = createList;

  if (!valueMap) {
    valueMap = Object.keys(map).reduce(function (p, key) {
      if (key) p[key] = key;
      return p;
    }, {});
  }

  Object.keys(valueMap).forEach(function (key) {
    if (!key) return;
    var d = Object.getOwnPropertyDescriptor(valueMap, key);
    if (d) Object.defineProperty(filter, key, d);
  });
  var external = options.external;

  if (external) {
    if (typeof external === 'function') external = external.call(filter, filter);

    if (external) {
      Object.getOwnPropertyNames(external).forEach(function (key) {
        var d = Object.getOwnPropertyDescriptor(external, key);
        d && Object.defineProperty(filter, key, d);
      });
    }
  }

  return filter;
}
//# sourceMappingURL=index.js.map